<style type="text/css">
	#open-orders-grid table { width: 385px !important }
	/*.balance { background-color: #D7FFB0; border-bottom: 1px solid #CCCCCC; font-size: 16px; padding: 5px 30px }*/
	.subtotal { float: right; font-size: 20px; font-weight: bold; margin-top: 8px }
	.minimum-amount { float: right; font-size: 20px; font-weight: bold; margin-top: 8px }
	/*.subtotal span { text-decoration: underline }*/
	.inline-error { margin-top: 10px !important }
	.inline-error strong { margin: 0 !important }
	.photos { background: none repeat scroll 0 0 #999999; list-style: none outside none; overflow: hidden; padding: 10px 10px 0 0;}
	.photos li {float: left;margin: 0 0 10px 10px;}
	.photo {background: none repeat scroll 0 0 #FFFFFF; border: 1px solid #777777; border-collapse: collapse;  padding: 0; width: 90px;}
	.photo .wrapper {height: 120px; padding: 0; position: relative; width: 90px;}
	.photo div.chk {background: none repeat scroll 0 0 #FF0000; border: 1px solid #FF0000; bottom: 8px;padding: 3px;position: absolute;right: 8px;z-index: 2;}
	.w44{width:440px}	 


</style>

<? $picker_id = md5(microtime()) ?>

<script type="text/javascript">
	window.TransferPopup.addEvent('loaded', function () {
		var self = this;
		<?= 'init_' . $picker_id . '();' ?>
		$('<?= $picker_id ?>').getElement('.search-fields a').addEvent('click', function () {
			var otherUserId = self.content.getElement('select[name=other_user_id]');
			var userType = self.content.getElement('input[name=user_type]').get('value');
			var userId = self.content.getElement('input[name=user_id]').get('value');
			//var escortId = self.content.getElement('input[name=escort_id]').get('value');
			
			if (userType == <?= USER_TYPE_SINGLE_GIRL ?> ) {
				otherUserId.setStyle('display', 'block');
				otherUserId.user_id = undefined;
			}
			else {
				otherUserId.setStyle('display', 'none');
				otherUserId.user_id = userId;
			}

			otherUserId.set('value', userId);

			openOrdersGrid.load();

			updateSubTotal();
		});

		this.content.getElement('input[name=amount]').addEvent('change', function () {
			updateSubTotal();
		});

		var orders = new Hash();
		
		var openOrdersGrid;
		var selectedOrdersGrid;
		var excludeIds = new Array();
		<? if ( $this->order ): ?>
		excludeIds.include(<?= $this->order->id ?>);
		<? endif ?>
		var initOrdersGrid = function (el, dataUrl, userIdField, statuses) {
			var getFilterParams = function () {
				var el1 = this.content.getElement('*[name=other_user_id]');
				// var el2 = this.content.getElement('*[name=user_id]');
				return { user_id: $chk(el1.user_id) ? el1.user_id : el1.getSelected()[0].get('value'), status: statuses };
			}.bind(this);

			var ExcludeLoader = new Class({
				Extends: Cubix.Grid.Loader,

				onLoaded: function (resp) {
					resp = JSON.decode(resp);

					if ( resp.data ) {
						resp.data.each(function (item) {
							if ( excludeIds.contains(item.id) ) {
								resp.data.each(function (i, k) {
									if ( i == item ) {
										resp.data[k] = undefined;
									}
								});
							}
						}.bind(this));

						resp.data = resp.data.clean();
					}

					this.fireEvent('load', resp);
				}
			});

			var grid = new Cubix.Grid(el, {
				identifier: { field: 'id' },
				<? if ( ! $this->order ): ?>
				preload: false,
				<? endif ?>
				header: [
					/*{ title: '', field: '', type: 'Checkbox', width: '15px' },*/
					{ title: 'Name', field: 'username', type: 'UserTypeIcon', width: '65px' },
					{ title: 'Order ID', field: 'system_order_id', type: 'string', width: '65px' },
					{ title: 'Order Date', field: 'order_date', type: 'DateTime', width: '105px' },
					{ title: 'Price', field: 'price', type: 'Currency', format: { currency: '<?= $this->currency('symbol') ?>' }, width: '65px' }
				],
				sort: {
					field: 'order_date',
					dir: 'DESC'
				},
				portioning: false,
				actions: [{ type: 'add', func: function (data) {
					var item = data;
					item.el = new Element('input', { type: 'hidden', name: 'orders[]', value: data.id }).inject(el.getParent('fieldset'));
					
					selectedOrdersGrid.options.data.options.data.data.include(item);
					excludeIds.include(data.id);

					selectedOrdersGrid.load();
					openOrdersGrid.load();
				} }],
				data: new ExcludeLoader({ url: dataUrl, params: getFilterParams })
			});

			grid.addEvent('loaded', function () {
				initCheckBoxes(grid);

				window.fireEvent('resize');
			});

			return grid;
		}.bind(this);

		var subtotalEl = this.content.getElement('.subtotal');
		var requiredEl = this.content.getElement('.minimum-amount');
		var updateSubTotal = function () {
			var subtotal = 0, required = 0;
			/*openOrdersGrid.tbody.getElements('input[type=checkbox]').each(function (el) {
				if ( el.get('checked') ) {
					subtotal += el.getParent('tr').rowData.price.toFloat();
				}
			});*/
			
			selectedOrdersGrid.options.data.options.data.data.each(function (el) {
				subtotal += parseFloat(el.price);
			});

			if ( $('<?= $picker_id ?>').getElement('.autocomplete input').autocompleter.selected ) {
				var balance = $('<?= $picker_id ?>').getElement('.autocomplete input').autocompleter.selected.token.balance.toFloat();
				var amount = this.content.getElement('input[name=amount]').get('value').toFloat();
				
				required = subtotal - amount - balance;
				if ( required < 0/* || subtotal == 0*/ ) required = 0;
				
				if ( subtotal > balance + amount/* instead: required > 0*/ ) {
					subtotalEl.setStyle('color', 'red');
				}
				else {
					subtotalEl.setStyle('color', null);
				}
			}

			subtotalEl.set('html', 'Total Selected: <span>' + subtotal.numberFormat() + '</span> <?= $this->currency('symbol') ?>')
			requiredEl.set('html', 'Amount Required: <span>' + required.numberFormat() + '</span> <?= $this->currency('symbol') ?>')
		}.bind(this);

		var initCheckBoxes = function (grid) {
			/*var checkAll = grid.thead.getElement('input[type=checkbox]').set('checked', '');
			
			checkAll.addEvent('click', function() {
				if ( this.get('checked') ) {
					grid.tbody.getElements('input[type=checkbox]').each(function(it){
						if ( it.get('id') != 'select-all' ) {
							it.set('checked', 'checked');
						}
					});
				}
				else {
					grid.tbody.getElements('input[type=checkbox]').each(function(it){
						if ( it.get('id') != 'select-all' ) {
							it.set('checked', '');
						}
					});
				}

				updateSubTotal();
			});*/

			/*grid.tbody.getElements('input[type=checkbox]').addEvent('change', function () {
				updateSubTotal();
			});*/
		};
		
		selectedOrdersGrid = new Cubix.Grid(this.content.getElements('.cx-grid')[1], {
			identifier: { field: 'id' },
			header: [
				/*{ title: '', field: '', type: 'Checkbox', width: '15px' },*/
				{ title: 'Name', field: 'username', type: 'UserTypeIcon', width: '65px' },
				{ title: 'Order ID', field: 'system_order_id', type: 'string', width: '65px' },
				{ title: 'Order Date', field: 'order_date', type: 'DateTime', width: '105px' },
				{ title: 'Price', field: 'price', type: 'Currency', format: { currency: '<?= $this->currency('symbol') ?>' }, width: '65px' }
			],
			sort: {
				field: 'order_date',
				dir: 'DESC'
			},
			portioning: false,
			actions: [{ type: 'remove', func: function (data, btn) {
				var data = btn.getParent('tr').rowData;
				var datum = selectedOrdersGrid.options.data.options.data.data;
				datum.each(function (item, k) {
					if ( item.id == data.id ) {
						datum[k] = undefined;
						window.TransferPopup.content.getElements('input[type=hidden]').each(function (input) {
							if ( input.get('name') == 'orders[]' && input.get('value') == data.id ) {
								input.destroy();
							}
						});
					}
				});
				selectedOrdersGrid.options.data.options.data.data = datum.clean();

				excludeIds.erase(data.id);
				
				selectedOrdersGrid.load();
				openOrdersGrid.load();
			} }],
			data: new Cubix.Grid.Loader.Static({ data: { data: [<?= $this->order ? json_encode($this->order) : '' ?>], count: 0 } })
		}).addEvent('loaded', function () {
			updateSubTotal();
			window.fireEvent('resize');
		});

		updateSubTotal();

		<? if ( $this->order ): ?>
		this.content.getElement('*[name=other_user_id]').user_id = <?= $this->order->user_id ?>;
		<? endif ?>
		var openOrdersGrid = initOrdersGrid(this.content.getElements('.cx-grid')[0], '/billing/orders/data', 'other_user_id', [<?= Model_Billing_Orders::STATUS_PENDING ?>, <?= Model_Billing_Orders::STATUS_PAYMENT_REJECTED ?>]);
		// var otherOpenOrdersGrid = initOrdersGrid(this.content.getElements('.cx-grid')[1], '/billing/orders/data', 'other_user_id', [<?= Model_Billing_Orders::STATUS_PENDING ?>, <?= Model_Billing_Orders::STATUS_PAYMENT_DETAILS_RECEIVED ?>]);

		this.content.getElement('*[name=other_user_id]').addEvent('change', function () {
			openOrdersGrid.load();
		});
		
		new Picker.Date(this.content.getElement('input[name=date_transfered]'), { pickerClass: 'datepicker',
			positionOffset: { x: -10, y: 0 }, allowEmpty: true, format: 'd M Y H:i', timePicker: true });

		//photos upload
		var uploadOverlay = new Cubix.Overlay(self.content.getElement('#uploaded-photos') , { showLoader: true });
		new Cubix.Button($('btn-photos-remove'), { onClick: function () {
		removePhotos();
		}.bind(this), icon: 'delete', classes: 'fright ml5', caption: 'Remove' });

		var init_uploader = function () {
		this.uploader = new Cubix.Uploader({
			url: '/billing/transfers/upload-img',
			fileFilter: {
				'Allowed Files (*.jpg, *.jpeg, *.gif, *.png, *.pdf)': '*.jpg; *.jpeg; *.gif; *.png; *.pdf; '
			}
		});

		this.uploader.addEvent('fileUploaded', function (resp) {
			if ( resp.status == 'success' ) {
				var photo = render_photo(resp).
				set('opacity', 0).
				inject(self.content.getElement('.photos').getElement('.clear'), 'before').
				tween('opacity', 1);
				
			}
			window.fireEvent('resize');
		})//.bind(this));
	};

	/* >>> Photos initialization */
	var render_photo = function (photo) {
		var container = new Element('table', {
			'class': 'photo'
		});

		var content = new Element('td', {}).inject(new Element('tr', {}).inject(container));

		var wrapper = new Element('div', { 'class': 'wrapper' }).inject(content);
		wrapper.data = photo;

		var checkbox = new Element('input', {
			type: 'checkbox',
			name: 'photos[]',
			value: photo.transfer_img_id,
			events: {
				change: function () {
					if ( checkbox.get('checked') ) {
						checkbox.set('checked', true);
					}
					else {
						checkbox.set('checked', false);
					}
				}
			}
		}).inject(new Element('div', { 'class': 'chk' }).inject(wrapper));

		var img = new Element('img', {
			src: photo.img_url
//			events: {
//				click: function () {
//					if ( checkbox.get('checked') ) {
//						checkbox.set('checked', false);
//					}
//					else {
//						checkbox.set('checked', true);
//					}
//				}
//			}
		}).inject(wrapper);
		//console.log(photo);
		var li = new Element('li');

		li.data = photo;

		container.inject(li);
		window.fireEvent('resize');

		return li;
	}.bind(this);

	var removePhotos = function(){
		var selection = get_selection('.photos');
		request_action( selection, function (resp) {
			selection.els.each(function (el) {
				el.getElements('input[type=checkbox]').set('checked', null);
			}.bind(this));

			selection.els.tween({ 'opacity': [1, 0], 'width': 0 }, function () {
				selection.els.destroy();
			});
		});
	};

	var get_selection = function (content) {

		var chks = self.content.getElement(content);

		var result = { ids: [], els: $$() };

		chks.getElements('input[type=checkbox]').each(function (chk) {
			if ( chk.get('checked') ) {
				result.ids.include(chk.get('value'));
				result.els.include(chk.getParent('li'));
			}
		});

		result.els.tween = function (opt, callback) {
			var opts = {};
			for ( var i = 0; i < result.els.length; i++ ) {
				opts[i] = opt;
			}

			new Fx.Elements(result.els, {
				onComplete: callback
			}).start(opts);
		}

		return result;
	};

	var request_action = function (selection, callback) {
		if ( ! selection.ids.length ) {
			alert('Please select some photos and then continue');
			return;
		}

		if ( ! confirm('Are you sure you want delete these photos?') ) {
			return;
		}

		uploadOverlay.disable();

		var ids = [];
		for ( i = 0; i < selection.ids.length; i++ ) {
			ids.include('photos[]=' + selection.ids[i]);
		}

		new Request({
			url: '/billing/transfers/remove-img?' + ids.join('&'),
			method: 'get',
			onSuccess: function (resp) {
				(callback.bind(this))(resp);
				 uploadOverlay.enable();
			}.bind(this)
		}).send();
	};


		var initTransferTypes = function () {
			var choose = function (choice) {
				var map = {
					all: [ 'first_name', 'last_name', 'country_id', 'city', 'var_symbol', 'transaction_id', 'pull_person_id', 'mtcn', 'comment', 'webmoney_account' ],
					0: [  ],
					1: [ 'first_name', 'last_name', 'country_id', 'var_symbol', 'comment' ],
					2: [ 'first_name', 'last_name', 'country_id', 'city', 'pull_person_id', 'mtcn', 'comment' ],
					3: [ 'first_name', 'last_name', 'country_id', 'transaction_id', 'comment' ],
					4: [ 'first_name', 'last_name', 'comment' ],
					5: [ 'first_name', 'last_name', 'transaction_id', 'comment', 'webmoney_account' ],
					6: [ 'first_name', 'last_name' ]
				};

				map.all.each(function (name) {
					var el = this.content.getElement('*[name=' + name + ']');
					el.set('disabled', 'disabled');
					el.getParent('.inner').addClass('disabled');
				}.bind(this));

				if ( $chk(map[choice]) ) {
					map[choice].each(function (name) {
						var el = this.content.getElement('*[name=' + name + ']');

						if ( choice == 5 ) {
							if ( name == 'first_name' || name == 'last_name' ) {
								el.getPrevious('label').getElement('span.required').destroy();
							}
							else if ( name == 'transaction_id' ) {
								new Element('span', {
									'class': 'required',
									html: ' *'
								}).inject(el.getPrevious('label'));
							}
						}

						el.set('disabled', null);
						el.getParent('.inner').removeClass('disabled');
					}.bind(this));
				}
				else {
					return;
				}
			}.bind(this);
			
			var select = this.content.getElement('select[name=transfer_type_id]');
			select.addEvent('change', function () { 
				choose(this.getSelected()[0].get('value'));
			});

			choose(0);
		}.bind(this);
		init_uploader();
		initTransferTypes();

		this.removeEvents('loaded');
	});
</script>

<form class="form-common" action="/billing/transfers/create" method="post">
	<div style="margin: 0 !important; margin-bottom: 10px !important" name="global_error"></div>

	<div class="mt10 fleft">
		<? $params = array('field_name' => 'user_id','field_type' => 'user_type', 'id' => $picker_id);
		if ( $this->order ) {
			$params['read_only'] = true;
			$params['user_id'] = $this->order->user_id;
		} ?>

		<?= $this->picker($params) ?>
	</div>

	<fieldset class="m0 fleft">
		<legend>Transfer</legend>

		<div class="inner">
			<label for="amount">Amount <span class="required">*</span></label>
			<input type="text" id="amount" name="amount" value="0.00" class="txt w9" style="text-align: right; font-weight: bold; background: #eef" />
		</div>
		
		<div class="inner">
			<label for="transfer_type_id">Type <span class="required">*</span></label>
			<select id="transfer_type_id" name="transfer_type_id" class="w12">
				<option value="0"> - - - </option>
				<? foreach ( $this->model->getTransferTypes() as $type ): ?>
				<option value="<?= $type->id ?>"><?= $type->name ?></option>
				<? endforeach ?>
			</select>
		</div>

		<div class="inner">
			<label for="date_transfered">Date <span class="required">*</span></label>
			<input type="text" id="date_transfered" name="date_transfered" class="txt w11" value="<?= time() ?>" />
		</div>
		<div class="clear"></div>
		
		<div class="inner">
			    <div id="demo-status" style="">
                    <p>
                        <a href="#" id="demo-browse">Browse Files</a> |
                        <a href="#" id="demo-clear">Clear List</a> |
                        <a href="#" id="demo-upload">Start Upload</a>
                    </p>
                    <div style="display: none">
                        <strong class="overall-title"></strong><br />
                        <img src="/js/fancyupload/assets/bar.gif" class="progress overall-progress" />
                    </div>
                    <div>
                        <strong class="current-title"></strong><br />
                        <img src="/js/fancyupload/assets/bar.gif" class="progress current-progress" />
                    </div>
                    <div class="current-text" style="display: none"></div>
                </div>

                <ul id="demo-list"></ul>
           
        </div>
		<div class="clear"></div>
		<div class="inner">
			<div id="uploaded-photos" class="fleft ">
				<ul class="photos w44">
					<div class="clear"></div>
				</ul>

				<div class="actions mt20">
					<!-- Buttons will be created in reversed order -->
					<a id="btn-photos-remove"></a>
					<div class="clear"></div>
				</div>
			</div>
		</div>
		<div class="clear"></div>
	</fieldset>
	<div class="clear"></div>

	<fieldset class="mt20 fleft">
		<legend>Transfer Details</legend>

		<div class="inner">
			<label for="first_name">First Name <span class="required">*</span></label>
			<input type="text" id="first_name" name="first_name" class="txt w16" value="" />
		</div>

		<div class="inner">
			<label for="last_name">Last Name <span class="required">*</span></label>
			<input type="text" id="last_name" name="last_name" class="txt w16" value="" />
		</div>

		<div class="clear"></div>

		<div class="inner">
			<label for="country">Country</label>
			<select id="country" name="country_id" class="w16">
				<option value="">- - -</option>
				<option value="" disabled="disabled">Important Countries</option>
				<? $model = new Model_Geography_Countries() ?>
				<? $c = false; foreach ( $model->ajaxGetAll(false) as $country ): ?>
				<? if ( ! $c && $country->ordering == 0 ): $c = true ?><option value="" disabled="disabled">-----------------------</option><? endif; ?>
				<option value="<?= $country->id ?>" <?= ( Cubix_Application::getById($this->request()->application_id)->country_id == $country->id ) ? 'selected="selected"' : '' ?>><?= $country->title ?></option>
				<? endforeach; ?>
			</select>
		</div>

		<div class="inner">
			<label for="city">City</label>
			<input type="text" id="city" name="city" class="txt w16" />
		</div>

		<div class="clear"></div>

		<div class="inner">
			<label for="var_symbol">Var. Symbol</label>
			<input type="text" id="var_symbol" name="var_symbol" class="txt w12" value="" />
		</div>

		<div class="inner">
			<label for="transaction_id">Transaction ID</label>
			<input type="text" id="transaction_id" name="transaction_id" class="txt w20" value="" />
		</div>
		<div class="clear"></div>

		<div class="inner">
			<label for="pull_person_id">Pull Person</label>
			<select name="pull_person_id" class="w14">
				<option value=""> - - - </option>
				<? $model = new Model_Billing_Transfers(); foreach ( $model->getPullPersons() as $person ): ?>
				<option value="<?= $person->id ?>"><?= $person->name ?></option>
				<? endforeach ?>
			</select>
		</div>

		<div class="inner">
			<label for="mtcn">MTCN</label>
			<input type="text" id="mtcn" name="mtcn" class="txt w18" value="" />
		</div>

		<div class="clear"></div>

		<div class="inner">
			<label for="webmoney_account">Webmoney Account <span class="required">*</span></label>
			<select name="webmoney_account" class="w14">
				<option value=""> - - - </option>
				<? $model = new Model_Billing_Transfers(); foreach ( $model->getWebmoneyAccounts() as $account ): ?>
				<option value="<?= $account->id ?>"><?= $account->account_type ?></option>
				<? endforeach ?>
			</select>
		</div>

		<div class="clear"></div>

		<div class="inner">
			<label for="comment">Comment</label>
			<textarea rows="1" id="comment" name="comment" class="txt w35"></textarea>
		</div>
	</fieldset>

	<div class="m0 mt20 fleft">
		<fieldset>
			<legend>Open Orders</legend>

			<select name="other_user_id" class="" style="display: none">
				<option value="">- - -&nbsp;&nbsp;</option>
				<? $model = new Model_Billing_Orders(); foreach ( $model->getUsersForSalesPerson() as $user ): ?>
				<option value="<?= $user->id ?>"><?= $user->name ?></option>
				<? endforeach ?>
			</select>

			<div class="cx-grid mt10" style="width: 467px; position: relative"></div>

			<label class="mt10">Selected Orders</label>
			<div class="cx-grid" style="width: 467px; position: relative">
				<? if ( $this->order ): ?>
				<input type="hidden" name="orders[]" value="<?= $this->order->getId() ?>" />
				<? endif ?>
			</div>

			<div class="fleft inline-error" name="limited"></div>
			<div class="subtotal">Total Selected: <span>0.00</span> <?= $this->currency('symbol') ?></div>
			<div class="clear"></div>
			<div class="minimum-amount">Amount Required: <span>0.00</span> <?= $this->currency('symbol') ?></div>
			<div class="clear"></div>
		</fieldset>

		<!-- <fieldset class="mt10 other-open-orders" style="display: none">
			<legend>Other Open Orders</legend>
			<div class="inner">
				<label>User</label>
				<select name="other_user_id" class="">
					<option value="">- - -&nbsp;&nbsp;</option>
					<? $model = new Model_Billing_Orders(); foreach ( $model->getUsersForSalesPerson() as $user ): ?>
					<option value="<?= $user->id ?>"><?= $user->name ?></option>
					<? endforeach ?>
				</select>
			</div>
			<div class="clear"></div>
			
			<div class="cx-grid mt10" style="width: 320px"></div>
		</fieldset> -->
	</div>
	<div class="clear"></div>
</form>

